<template>
  <div>
    <Settings
      :showSettings="show"
      :config="settings"
      @cancel="cancelSettings"
      @apply="confirmSettings"
    />
    <div class="roomContainer">
      <Room
        v-for="(room, index) in dept.rooms"
        :key="index"
        :dept="dept"
        :roomNumber="room.number"
        :patientId="hasPatient(room)"
        :facilities="room.facilities"
        :mapView="mapView"
        :width="room.width"
        :length="room.length"
        :x="room.x"
        :y="room.y"
        :configData="settings"
      />
    </div>
    <q-page-sticky position="top-right">
      <q-btn
        flat
        color="grey"
        icon="fas fa-cog"
        fab
        @click="showSettings()"
      />
    </q-page-sticky>
  </div>
</template>

<script>
import Room from '../components/Room'
import ErrorService from '../services/ErrorService'
import Settings from '../components/Settings'

export default {
  components: {
    Room,
    Settings
  },
  props: {
    dept: Object,
    mapView: Boolean
  },
  data: () => ({
    settings: {
      heartrate: {
        upper: 130,
        lower: 60
      },
      bloodpressure: {
        upper: 140,
        lower: 70
      },
      showNumber: true,
      showFacilities: true,
      showPic: true,
      showNextAction: true,
      showMonitoring: true,
      hoursTreshold: 120,
      alarm: false,
      free: '#ffffff',
      occupied: '#2ecc71',
      overdue: '#cd6133',
      emergency: '#b33939',
      warning: '#F79F1F'
    },
    searchValue: ' ',
    show: false
  }),
  methods: {
    hasPatient (room) {
      if (typeof (room.patient) !== 'undefined') {
        return room.patient
      } else {
        ErrorService.log('This room is not occupied.')
        return -1
      }
    },
    showSettings () {
      this.show = true
    },
    cancelSettings () {
      this.show = false
    },
    confirmSettings () {
      this.show = false
    }
  }
}
</script>

<style lang="scss" scoped>
.roomContainer {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
}

@media screen and (max-width: 900px) {
  .roomContainer {
    display: flex;
    flex-direction: column;
    width: 50%;
    margin: 0 auto;
  }
}
</style>
